//
// t@C : blinker.c
//
//	Tv       : ܂܂iŁjCg[X TvvO
//

/* ITRON(TOPPERS/JSP) API */
#include "kernel.h"
#include "kernel_id.h"

/* Mindstorms NXT API */
#include "ecrobot_interface.h"

/* |Uqp[^ */
#include "balancer.h"


/* L̃|[g`̓ZT[ƃ[^[̔zɍ킹ĕύXKv܂ */
#define MOTOR_RIGHT		NXT_PORT_B
#define MOTOR_LEFT		NXT_PORT_C
#define TOUCH_SENS		NXT_PORT_S2
#define LIGHT_SENS		NXT_PORT_S3
#define GYRO_SENS		NXT_PORT_S4


/* L̃p[^̓ZT/ɍ킹ă`[jOKv܂ */
#define GYRO_OFFSET  604 /* WCZTItZbgl(px0[deg/sec])	*/
#define THRESHOLD    .7F /* CGbW臒l								*/


static float brightness;	/* R[Xx			*/
static U16 lightDowned;		/* ̌ZT[l	*/
static U16 lightUpped;		/* _̌ZT[l	*/


//*****************************************************************************
// FUNCTION		: jsp_systick_low_priority
// ARGUMENT		: none
// RETURN		: none
// DESCRIPTION 	: 1msec periodical ISR
//*****************************************************************************
void jsp_systick_low_priority(void)
{
	if (get_OS_flag()) /* check whether JSP already started or not */
	{
		isig_tim();          /* cyclic task dispatcher */
		check_NXT_buttons(); /* this must be called here */
	}
}



//*****************************************************************************
// FUNCTION		: ecrobot_device_initialize
// ARGUMENT		: none
// RETURN		: none
// DESCRIPTION 	: ECRobot device init hook function
//*****************************************************************************
void ecrobot_device_initialize(void)
{
	// Bluetooth
	ecrobot_init_bt_slave("1234");	/* pXL[ "1234" */

	// [^~ iu[L[hj
	nxt_motor_set_speed(MOTOR_LEFT,  0, 1);	/* [^ */
	nxt_motor_set_speed(MOTOR_RIGHT, 0, 1);	/* E[^ */
}



//*****************************************************************************
// FUNCTION		: ecrobot_device_terminate
// ARGUMENT		: none
// RETURN		: none
// DESCRIPTION 	: ECRobot device term hook function
//*****************************************************************************
void ecrobot_device_terminate(void)
{
	// Bluetoothؒf
	ecrobot_term_bt_connection();

	// [^~ iu[L[hj
	nxt_motor_set_speed(MOTOR_LEFT,  0, 1);	/* [^ */
	nxt_motor_set_speed(MOTOR_RIGHT, 0, 1);	/* E[^ */

	// u[L邽߂̑҂
	systick_wait_ms(500);
}



//=============================================================================
// ^XN	: TSK_STA
// Tv		: X^[^[^XN
//
void tsk_starter(VP_INT exinf)
{
	balance_init();							/* |Uq䏉			*/
	nxt_motor_set_count(MOTOR_LEFT, 0);		/* [^GR[_Zbg	*/
	nxt_motor_set_count(MOTOR_RIGHT, 0);	/* E[^GR[_Zbg	*/

	/* ^b`ZTҋ@ */
	while (ecrobot_get_touch_sensor(TOUCH_SENS) == 0) {
		;	/* DO NOTHING */
	}

	sta_cyc(CYC);	/* Nnh[N	*/

	ext_tsk();		/* ^XN̏I			*/
}



//=============================================================================
// nh	: CYC
// Tv		: Nnh
//

void cyc(VP_INT exinf)
{
	U32 systime;

	systime = systick_get_ms();	// VXe擾

	//
	// 4~b
	//
	switch (systime % 4) {
		case 0 :
			;					// DO NOTHING
			break;
		case 1 :
			iact_tsk(TSK_BLN);	// |TASKN
			iact_tsk(TSK_LOG);	// K[TASKN
			break;
		case 2 :
		case 3 :
		default:
			;					// DO NOTHING
	}

	//
	// 40~b
	//
	switch (systime % 40) {
		case 0 :
			iact_tsk(TSK_LON);	// LED_TASKN
			iact_tsk(TSK_LMN);	// xvTASKN
			break;
		case 20 :
			iact_tsk(TSK_LOF);	// LEDTASKN
			iact_tsk(TSK_LMN);	// xvTASKN
			break;
		default :
			;					// DO NOTHING
	}
}



//=============================================================================
// ^XN	: TSK_BLN
// Tv		: |ioT[j^XN
//
void tsk_balancer(VP_INT exinf)
{
	signed char forward;		/* Oi: -100(i)`100(Oi)		*/
	signed char turn;			/* 񖽗: -100()`100(E)	*/
	signed char pwm_L, pwm_R;	/* E[^PWMo						*/

	forward = 0;	/* Oi(~) */

	if (brightness < THRESHOLD) {
		turn = 50;  /* E */
	} else {
		turn = -50; /*  */
	}

	/* |Uq */
	balance_control(
		(float)forward,                              /* Oi			*/
		(float)turn,                                 /* 񖽗				*/
		(float)ecrobot_get_gyro_sensor(GYRO_SENS),   /* WCZTl			*/
		(float)GYRO_OFFSET,                          /* WCZTItZbgl	*/
		(float)nxt_motor_get_count(MOTOR_LEFT),      /* [^]px[deg]	*/
		(float)nxt_motor_get_count(MOTOR_RIGHT),     /* E[^]px[deg]	*/
		(float)ecrobot_get_battery_voltage(),        /* obed[mV]		*/
		&pwm_L,  /* [^PWMo͒l */
		&pwm_R); /* E[^PWMo͒l */

	nxt_motor_set_speed(MOTOR_LEFT,  pwm_L, 1); /* [^PWMo̓Zbg */
	nxt_motor_set_speed(MOTOR_RIGHT, pwm_R, 1); /* E[^PWMo̓Zbg */

	/* ^XN̏I */
	ext_tsk();
}



//=============================================================================
// ^XN	: TSK_LON
// Tv		: LED_^XN
//
void tsk_lightOn(VP_INT exinf)
{
	/*ԐFLED̎ʌv */
	lightDowned = ecrobot_get_light_sensor(LIGHT_SENS);
	
	/* ԐFLED_ */
	ecrobot_set_light_sensor_active(LIGHT_SENS);
	
	/* ^XN̏I */
	ext_tsk();
}



//=============================================================================
// ^XN	: TSK_LOF
// Tv		: LED^XN
//
void tsk_lightOff(VP_INT exinf)
{
	/* ԐFLED_̎ʌv */
	lightUpped = ecrobot_get_light_sensor(LIGHT_SENS);
	
	/* ԐFLED */
	ecrobot_set_light_sensor_inactive(LIGHT_SENS);
	
	/* ^XN̏I */
	ext_tsk();
}



//=============================================================================
// ^XN	: TSK_LMN
// Tv		: xvi~m[^[j^XN
//
void tsk_luminometer(VP_INT exinf)
{
	U16 lightDiff;				/* _Ə̕ω	*/
	float k;					/* ZT[`␳l	*/
	
	/* ZT[̕ωʂvZ */
	if (lightDowned - lightUpped > 0) {
		lightDiff = lightDowned - lightUpped;
	} else {
		lightDiff = 0U;
	}
	
	/* ZT[`␳WvZ if[^j */
	k = (1.0382E-3 * lightDowned - 6.3295E-1) * lightDowned + 1.1024E+2;
	
	/* R[XxvZ */
	brightness = (float) lightDiff / k;
	
	/* ^XN̏I */
	ext_tsk();
}



//=============================================================================
// ^XN	: TSK_LOG
// Tv		: K[^XN
//
void tsk_logger(VP_INT exinf)
{
	S8 dat1;
	S8 dat2;
	
	dat1 = (S8)(brightness * 100);
	dat2 = 0;
	
	/* Bluetooth data logger */
	ecrobot_bt_data_logger(dat1, dat2);

	/* ^XN̏I */
	ext_tsk();
}
